<?php 



 if( ! class_exists( 'WP_List_Table' ) ) {

    require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );

}



class Inventory_List_Table extends WP_List_Table {



                   



	public function __contruct()

	{

      global $status, $page;

                

        //Set parent defaults

        parent::__construct( array(

            'singular'  => 'inventory',     

            'plural'    => 'inventories',    

            'ajax'      => false        

        ) );

	}



		public function get_columns(){

	  $columns = array( 'cb'        => '<input type="checkbox" />',	       	   

	    'creditor'      => 'Creditor',

	    'credlimit'      => 'Credit Limit',	    

	    'maxspots'      => 'Max Spots',

      'cardyear'      => 'Year',

      'cardmonth'     => 'Month',

	    'stmntday'      => 'Stmnt day',

	    'commision'      => 'Commission',

      'uid'      => 'Seller Info',

      'status'    => 'Status'   

	  );

	  return $columns;

	}



				public function get_sortable_columns() {

			  $sortable_columns = array(

			    'commision'  => array('commision',false),

			    'status' => array('status',false),

			    'credlimit'   => array('credlimit',false)

			  );

			  return $sortable_columns;

			}



	public function prepare_items() {



	  global $wpdb;

			     $table_name = $wpdb->prefix . 'tradelinesi';

                 //$tradelines = $wpdb->get_results( "SELECT id, tradelineid, status, statusdate, creditor, credlimit, opendate, maxspots, commision, stmntday, nxtrptdate FROM $table_name", ARRAY_N);

	

	  $columns = $this->get_columns();

	  $hidden = array();

	  $sortable = $this->get_sortable_columns();

	  $this->_column_headers = array($columns, $hidden, $sortable);  

      $this->process_bulk_action();





        $total_items = $wpdb->get_var("SELECT COUNT(id) FROM $table_name");

        $per_page = 15;



        $paged = isset($_REQUEST['paged']) ? max(0, (intval($_REQUEST['paged']) - 1)) : 0;

        $offset=$per_page*$paged;

        $orderby = (isset($_REQUEST['orderby']) && in_array($_REQUEST['orderby'], array_keys($this->get_sortable_columns()))) ? $_REQUEST['orderby'] : 'id';

        $order = (isset($_REQUEST['order']) && in_array($_REQUEST['order'], array('asc', 'desc'))) ? $_REQUEST['order'] : 'asc';



        $this->items = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table_name ORDER BY $orderby $order LIMIT %d OFFSET %d", $per_page, $offset), ARRAY_A);



        $this->set_pagination_args(array(

            'total_items'   => $total_items,

            'per_page'      => $per_page,

            'total_pages'   => ceil($total_items / $per_page),

        ));



	    



	}



			



	public function column_default( $item, $column_name ) 

	{

  switch( $column_name ) { 

    case 'status':       

    case 'credlimit':

    case 'maxspots':

    case 'cardyear':

    case 'cardmonth':

    case 'stmntday':

    case 'commision':

    return $item[ $column_name ];

      break;

    case 'creditor': 

           if($item[ $column_name ]=='notinlist') 

           {

            return $item[ 'crdtrname' ];

           }

           else

           {

            return wp_get_attachment_image( $item[ $column_name ], array('100', '20'), $icon = false, $attr = '' );

           }

       break;

       case 'uid': 

        $seller=get_userdata( $item[ $column_name ] );



            $data= $seller->first_name.' '. $seller->last_name.'<br/>';

            $data .= get_user_meta( $item[ $column_name ], 'phone_num', true );

           return $data;

    default:

      return print_r( $item, true ) ; //Show the whole array for troubleshooting purposes

  }

   }



   public  function column_tradelineid($item){

        

        //Build row actions

        $actions = array(

            'edit'      => sprintf('<a href="?page=%s&action=%s&inventory=%d">Edit</a>',$_REQUEST['page'],'edit',$item['id']),

            'delete'    => sprintf('<a href="?page=%s&action=%s&inventory=%d">Delete</a>',$_REQUEST['page'],'delete',$item['id']),

        );

        

        //Return the title contents

        return sprintf('%1$s %2$s',

            /*$1%s*/ $item['tradelineid'],           

            /*$3%s*/ $this->row_actions($actions)

        );

    }







    public function get_bulk_actions() {

        $actions = array(

            'delete'    => 'Delete',

            'active'    => 'Activate',

            'deactive'  => 'Deactivate',

            'outofstock'=> 'Out of Stock'

        );

        return $actions;

    }





   public  function column_cb($item){

        return sprintf(

            '<input type="checkbox" name="%1$s[]" value="%2$s" />',

            /*$1%s*/ 'inventory',  //Let's simply repurpose the table's singular label ("movie")

            /*$2%s*/ $item['id']                //The value of the checkbox should be the record's id

        );

    }

    public function process_bulk_action() {        

        //Detect when a bulk action is being triggered...

        global $wpdb;

         $table_name = $wpdb->prefix . 'tradelinesi';



        if ('delete' === $this->current_action()) {



        	if (is_array($_GET['inventory'])) 

        	{

            foreach ($_GET['inventory'] as $id) 

            {

                 $wpdb->delete($table_name, array('id' => $id));

            }



            }

            else

             {

             	 $wpdb->delete($table_name, array('id' => $_GET['inventory']));

             }

        }



        if ('active' === $this->current_action()) {



          if (is_array($_GET['inventory'])) 

          {

            foreach ($_GET['inventory'] as $id) 

             {

                 
              
              $userr = $wpdb->get_row($wpdb->prepare("SELECT uid FROM $table_name WHERE id=%d", $id));

              $seller=get_userdata( $userr->uid );

        $activated=$wpdb->update( 

                  $table_name, 

                  array( 

                    'status' => 'Active'  // string                    

                  ), 

                  array( 'ID' => $id ), 

                  array( 

                    '%s' // value1                   

                  ), 

                  array( '%d' ) 

                );

            if($activated > 0)
            {
              $to      = $seller->user_email;
                $subject = "Your Credit Card Activated";
                $message = "Your Credit card has been activated.";
                $siteemail = 'wordpress@winwintradelines.com';
               $from_name = get_option('blogname');
                $headers   = array(
            "From: \"{$from_name}\" <{$siteemail}>\n",
            "Cc: WinWin<info@winwintradelines.com>\n"
        );
        $headers   = apply_filters('new_user_approve_email_header', $headers);
                wp_mail($to, $subject, $message, $headers);
            }


             }



          }

         

        }







         if ('deactive' === $this->current_action()) {



          if (is_array($_GET['inventory'])) 

          {

            foreach ($_GET['inventory'] as $id) 

             {

                



        $wpdb->update( 

                  $table_name, 

                  array( 

                    'status' => 'Inactive'  // string                    

                  ), 

                  array( 'ID' => $id ), 

                  array( 

                    '%s' // value1                   

                  ), 

                  array( '%d' ) 

                );

             }



          }

         

        }





         if ('outofstock' === $this->current_action()) {



          if (is_array($_GET['inventory'])) 

          {

            foreach ($_GET['inventory'] as $id) 

             {

                 



        $wpdb->update( 

                  $table_name, 

                  array( 

                    'status' => 'outofstock'  // string                    

                  ), 

                  array( 'ID' => $id ), 

                  array( 

                    '%s' // value1                   

                  ), 

                  array( '%d' ) 

                );

             }



          }

         

        }

        

    }





    



 







}







?>