jQuery(document).ready(function($) {

    jQuery('form#winwin_register').on('submit', function(e) {

        jQuery('form#winwin_register input').css('border-color', '#CCCCCC');
        jQuery('label.radiobtn').removeClass('highlight');
        jQuery('.terms').removeClass('highlight');

        jQuery('form#winwin_register p.status').show().text('Checking info, Please wait...');

        var errors = new Array;
        var fname = jQuery('form#winwin_register #fname').val();
        var lname = jQuery('form#winwin_register #lname').val();
        var username = jQuery('form#winwin_register #username').val();
        var password = jQuery('form#winwin_register #password').val();
        var ps_strong = jQuery('form#winwin_register #ps_strong').val();
        var password2 = jQuery('form#winwin_register #password_retyped').val();
        var mphone = jQuery('form#winwin_register #mphone').val();
        var hereto = jQuery('form#winwin_register input[name=hereto]:checked').val();
        var referredby = jQuery('form#winwin_register input[name=referredby]').val();
        var terms = jQuery('form#winwin_register #terms').is(':checked');
        var register = jQuery('form#winwin_register #register').val();

        if (!fname) {
            errors.push('Please enter your First name');
            jQuery('#fname').css('border-color', '#c22020');
        }

        if (!lname) {
            errors.push('Please enter your Last name');
            jQuery('#lname').css('border-color', '#c22020');
        }


        if (!mphone) {
            errors.push('Please enter your Phone');
            jQuery('#mphone').css('border-color', '#c22020');
        }

        if (!password) {
            errors.push('Please enter your Phone');
            jQuery('#password').css('border-color', '#c22020');
        }

        if (ps_strong != "strong") {
            errors.push('Please enter your Phone');
            jQuery('#password').css('border-color', '#c22020');
        }

        if (!password2) {
            errors.push('Please enter your Phone');
            jQuery('#password_retyped').css('border-color', '#c22020');
        }

        if (password2 != password) {
            errors.push('Please enter your Phone');
            jQuery('#password_retyped').css('border-color', '#c22020');
        }

        if (!hereto) {
            errors.push('Please enter your SSN');
            jQuery('label.radiobtn').addClass('highlight');
        }

        if (!isValidEmailAddress(username)) {
            errors.push('Please enter a valid Email');
            jQuery('#username').css('border-color', '#c22020');
        }

        if (!terms) {
            errors.push('Please ensure you have the correct SSN');
            jQuery('.terms').addClass('highlight');
        }


        if (errors.length == 0) {
            console.log(hereto);
            jQuery.ajax({
                type: 'POST',
                dataType: 'json',
                url: winwin_object.winwin_ajax_url,
                data: {
                    'action': 'ajaxregister',
                    'fname': fname,
                    'lname': lname,
                    'username': username,
                    'password': password,
                    'hereto': hereto,
                    'referredby': referredby,
                    'mphone': mphone,
                    'register': register
                },
                success: function(data) {

                    if (data.error == true) {
                        jQuery('form#winwin_register p.status').text(data.message);
                    }

                    if (data.error == false) {
                        jQuery('form#winwin_register p.status').text('');
                        jQuery('form#winwin_register span#password-strength').text('');
                        jQuery('form#winwin_register')[0].reset();
                        jQuery('.entry-content').append('<div class="winwin_popup"><div class="winwin_poppup_inner">' + data.message + '<span class="pop_upclose">X</span></div></div>');
                    }



                }
            });
        } else {
            jQuery('form#winwin_register p.status').show().text('The form having errors, please fix');
        }




        e.preventDefault();
    });


    jQuery('form#login').on('submit', function(e) {
        jQuery('form#login p.status').show().text('Sending user info, please wait...');
        jQuery.ajax({
            type: 'POST',
            dataType: 'json',
            url: winwin_object.winwin_ajax_url,
            data: {
                'action': 'ajaxlogin',
                'username': jQuery('form#login #username').val(),
                'password': jQuery('form#login #password').val(),
                'security': jQuery('form#login #security').val(),
                'redirect': jQuery('form#login #redirect').val()
            },
            success: function(data) {
                jQuery('form#login p.status').text(data.message);
                if (data.loggedin == true) {
                    document.location.href = data.redirect;
                }
            }
        });
        e.preventDefault();
    });

    jQuery('form#resetpass').on('submit', function(e) {
        jQuery('form#resetpass p.status').show().text('Reseting password, please wait...');
        jQuery.ajax({
            type: 'POST',
            dataType: 'json',
            url: winwin_object.winwin_ajax_url,
            data: {
                'action': 'ajaxpassword',
                'username': jQuery('form#resetpass #rusername').val(),
                'rpass': jQuery('form#resetpass #rpass').val()
            },
            success: function(data) {
                jQuery('form#resetpass p.status').text(data.message);
                if (data.error == false) {
                    jQuery('form#resetpass #rusername').val('');
                }

            }
        });
        e.preventDefault();
    });


    jQuery('.changepass').on('click', function(e) {

        jQuery(this).fadeOut();
        jQuery('form#changepass').fadeIn(500);

    });

    jQuery('.cancel_pchange').on('click', function(e) {
        e.preventDefault();
        jQuery('form#changepass').fadeOut(500);
        jQuery('.changepass').fadeIn();

    });

    jQuery('form#changepass').on('submit', function(e) {

        jQuery('form#changepass p.status').show().text('Changing password, please wait...');

        var pass = jQuery('form#changepass #cpass').val();
        var rpass = jQuery('form#changepass #crpass').val();
        var pstrong = jQuery('form#changepass #ps_strong').val();
        if ((pstrong == 'strong') && (rpass == pass)) {
            console.log(pass);

            jQuery.ajax({
                type: 'POST',
                dataType: 'json',
                url: winwin_object.winwin_ajax_url,
                data: {
                    'action': 'changepassword',
                    'pass': pass,
                    'chpass': jQuery('form#changepass #chpass').val()

                },
                success: function(data) {
                    jQuery('form#changepass p.status').text(data.message);
                    if (data.error == false) {
                        jQuery('form#changepass #cpass').val('');
                        jQuery('form#changepass #crpass').val('');
                        jQuery('form#changepass span#password-strength').text('');
                    }

                }
            });
        } else {

            jQuery('form#changepass p.status').text("Form having errors.");
        }
        e.preventDefault();
    });


    jQuery('#password').keyup(function() {
        jQuery('#password-strength').html(checkStrength(jQuery('#password').val()));
    });

    jQuery('#cpass').keyup(function() {
        jQuery('#password-strength').html(checkStrength(jQuery('#cpass').val()));
    });




    jQuery('#crpass').keyup(function() {
        var password = jQuery('#cpass').val();
        var password2 = jQuery(this).val();
        jQuery('#password-strength').html(passwordMatch(password, password2));
    });

    jQuery('#password_retyped').keyup(function() {
        var password = jQuery('#password').val();
        var password2 = jQuery(this).val();
        jQuery('#password-strength').html(passwordMatch(password, password2));
    });

 jQuery('.own-winwin-table.seller').on('click', 'input#card_received', function(e) {
    // alert('1');
        var dataid = $(this).attr("data-uniid");
        var uid = $(this).data("id");
        var tradeid = $(this).data("trade");
        var checkval = $(this).is(":checked");
        // alert(dataid+'=='+uid+'=='+tradeid+'=='+checkval);
        if (checkval == true) {var card_rec = 1;}else{var card_rec = 0;}
        // alert('1');
        if (dataid != '') {
            jQuery.ajax({
                    type: 'POST',
                    dataType: 'json',
                    url: winwin_object.winwin_ajax_url,
                    data: {
                        'action': 'credit_card_received',
                        'dataid': dataid,
                        'uid': uid,
                        'tradeid': tradeid,
                        'card_rec': card_rec
                    },
                    success: function(response) {

                        // if (response.status == 1) {
                        // jQuery('tr td.content.cont-uid-'+response.uid).html('You have added this user to credit card.');
                        // // window.location.href = data.redirect;
                        // jQuery('#btn-uid-'+response.uid).remove();
                        // // jQuery('#yearcard').prop('disabled', 'disabled');
                        // }
                        jQuery('#submit_message_apc').html(response);

                    }
                });
        }else{
            alert('Please first added this user to the credit card.');
            $(this). prop("checked", false);
        }
 });
 jQuery('tr.ifnotadd td').on('click', 'button', function(e) {
    // function addusertocard(uid, tradeid){
        // var dataid = $(this).data("uniid");
        var uid = $(this).data("id");
        var tradeid = $(this).data("trade");
        var orderid = $(this).data("orderid");
        // alert(orderid);
        jQuery.ajax({
                type: 'POST',
                dataType: 'json',
                url: winwin_object.winwin_ajax_url,
                data: {
                    'action': 'add_user_to_card',
                    'uid': uid,
                    'tradeid': tradeid,
                    'orderid': orderid
                },
                success: function(response) {
                    if (response.status == 1) {
                        // if (response.id) {
                           // alert(uid);
                            // $(this).data("uniid").val();
                            $('.check'+uid).attr('data-uniid', response.id);
                        // }
                    jQuery('tr td.content.cont-uid-'+response.uid).html('You have added this user to credit card.');
                    // window.location.href = data.redirect;
                    jQuery('#btn-uid-'+response.uid).remove();
                    // jQuery('#yearcard').prop('disabled', 'disabled');
                    }
                    jQuery('#submit_message_apc').html(response.html);

                }
            });
    });


    function checkStrength(password) {
        var strength = 0
        if (password.length < 7) {
            jQuery('#password-strength').removeClass();
            jQuery('#password-strength').addClass('short');
            return 'Too short';
        }
        if (password.length > 6) strength += 1
        // If password contains both lower and uppercase characters, increase strength value.
        if (password.match(/([a-z].*[A-Z])|([A-Z].*[a-z])/)) strength += 1
        // If it has numbers and characters, increase strength value.
        if (password.match(/([a-zA-Z])/) && password.match(/([0-9])/)) strength += 1
        // If it has one special character, increase strength value.
        if (password.match(/([!,%,&,@,#,$,^,*,?,_,~])/)) strength += 1
        // If it has two special characters, increase strength value.
        if (password.match(/(.*[!,%,&,@,#,$,^,*,?,_,~].*[!,%,&,@,#,$,^,*,?,_,~])/)) strength += 1
        // Calculated strength value, we can return messages
        // If value is less than 2
        if (strength < 3) {
            jQuery('#password-strength').removeClass();
            jQuery('#ps_strong').val('weak');
            return 'Weak';
        } else if (strength == 3) {
            jQuery('#password-strength').removeClass();
            jQuery('#ps_strong').val('good');
            return 'Almost';
        } else {
            jQuery('#password-strength').removeClass();
            jQuery('#ps_strong').val('strong');
            return 'Strong';
        }
    }

    function passwordMatch(password, password2) {
        if (password2 != password) {
            return 'Mismatch';
        } else {
            return checkStrength(password);
        }
    }



    jQuery('form#buyer_more_info_form').on('submit', function(e) {

        jQuery('form#buyer_more_info_form p.status').text('Checking info, Please wait...');

        jQuery('form#buyer_more_info_form input, form#buyer_more_info_form select').css('border-color', '#CCCCCC');

        var errors = new Array;
        var fname = jQuery('#fname').val();
        var lname = jQuery('#lname').val();
        var street = jQuery('#street').val();
        var city = jQuery('#city').val();
        var state = jQuery('#state').val();
        var zip = jQuery('#zip').val();
        var bemail = jQuery('#bemail').val();
        var phone = jQuery('#phone').val();
        var ssn = jQuery('#ssn').val();
        var tssn = jQuery('#truessn').is(':checked');
        var bmore = jQuery('#bmore').val();

        if (!fname) {
            errors.push('Please enter your First name');
            jQuery('#fname').css('border-color', '#c22020');
        }

        if (!lname) {
            errors.push('Please enter your Last name');
            jQuery('#lname').css('border-color', '#c22020');
        }

        if (!street) {
            errors.push('Please enter Street');
            jQuery('#street').css('border-color', '#c22020');
        }

        if (!city) {
            errors.push('Please enter your City');
            jQuery('#city').css('border-color', '#c22020');
        }

        if (!state) {
            errors.push('Please choose your State');
            jQuery('#state').css('border-color', '#c22020');
        }

        if (!zip) {
            errors.push('Please choose your State');
            jQuery('#zip').css('border-color', '#c22020');
        }

        if (!phone) {
            errors.push('Please enter your Phone');
            jQuery('#phone').css('border-color', '#c22020');
        }

        if (!ssn) {
            errors.push('Please enter your SSN');
            jQuery('#ssn').css('border-color', '#c22020');
        }

        if (!isValidEmailAddress(bemail)) {
            errors.push('Please enter a valid Email');
            jQuery('#bemail').css('border-color', '#c22020');
        }

        if (!tssn) {
            errors.push('Please ensure you have the correct SSN');
            jQuery('#truessn').parent().fadeOut('500').fadeIn();
        }


        if (errors.length == 0) {
            console.log(state);
            jQuery.ajax({
                type: 'POST',
                dataType: 'json',
                url: winwin_object.winwin_ajax_url,
                data: {
                    'action': 'buyer_more_info_save',
                    'fname': fname,
                    'lname': lname,
                    'street': street,
                    'city': city,
                    'email': bemail,
                    'state': state,
                    'zip': zip,
                    'phone': phone,
                    'ssn': ssn,
                    'bmore': bmore
                },
                success: function(data) {
                    jQuery('form#buyer_more_info_form p.status').text(data.message);
                    window.location.href = data.redirect;

                }
            });
        }

        jQuery('form#resetpass p.status').show().text('Reseting password, please wait...');
        e.preventDefault();
    });


    jQuery('form#login').on('click', 'a.lost_pswd', function(e) {
        e.preventDefault();
        console.log('button click working');
        jQuery('form#login').hide();
        jQuery('form#resetpass').fadeIn(500);

    });

    jQuery('form#resetpass').on('click', 'a.back_to_login', function(e) {
        e.preventDefault();
        console.log('button click working');
        jQuery('form#resetpass').hide();
        jQuery('form#login').fadeIn(500);

    });


    jQuery('#winwin_trades').on('click', 'button.add_to_cart', function(e) {
        e.preventDefault();
        console.log('button click working');
        var tradeline_id = jQuery(this).data('id');
        jQuery.ajax({
            url: winwin_object.winwin_ajax_url,
            type: 'post',
            data: {
                action: 'winwin_add_to_cart',
                tid: tradeline_id
            },
            success: function(response) {

                jQuery('.add_to_cart_result').html('<div class="winwin_popup"><div class="winwin_poppup_inner">' + response + '<span class="pop_upclose">X</span></div></div>');

                if (response.cartempty == 'no') {

                    if (jQuery('a.sign.cart_info').length > 0) {
                        jQuery('a.sign.cart_info span.ccount').html(response.cnt);
                    } else {
                        jQuery('div.right_menu').append('<a href="' + response.crturl + '" class="sign cart_info">Cart<span class="ccount">' + response.cnt + '</span> </a>')
                    }

                    if (jQuery('span.discount_info').length > 0) {

                        if (response.cnt == 1) {
                            jQuery('span.discount_info').html('Add another card to recieve a 10% discount on all tradelines, or two or more for a 20% discount.');
                        }
                        if (response.cnt == 2) {
                            jQuery('span.discount_info').html('Add one or more card to recieve a 20% discount on all tradelines. ');
                        }
                        if (response.cnt > 2) {
                            jQuery('span.discount_info').remove();
                        }

                    } else {
                        if (response.cnt == 1) {
                            jQuery('div.right_menu').append('<span class="discount_info">Add another card to recieve a 10% discount on all tradelines, or two or more for a 20% discount.</span>');
                        }
                        if (response.cnt == 2) {
                            jQuery('div.right_menu').append('<span class="discount_info">Add one or more card to recieve a 20% discount on all tradelines. </span>');
                        }
                        if (response.cnt > 2) {
                            jQuery('span.discount_info').remove();
                        }
                    }
                }
            }
        });
        //jQuery(this).hide();            
    });
    jQuery('#winwin_cart').on('click', 'a.remove_from_cart', function(e) {
        e.preventDefault();
        console.log('remove link click working');
        var tradeline_id = jQuery(this).data('id');
        jQuery.ajax({
            url: winwin_object.winwin_ajax_url,
            type: 'post',
            data: {
                action: 'winwin_remove_from_cart',
                tid: tradeline_id
            },
            success: function(response) {
                jQuery('.add_to_cart_result').html(response);
                if (response.cartempty == 'yes') {
                    jQuery('#winwin_cart').html('<h4>Your Cart is EMPTY</h4>');
                    jQuery('a.sign.cart_info').hide();
                    jQuery('span.discount_info').hide();
                } else {
                    if (!response.oid) {
                        jQuery('.row' + tradeline_id + '').remove();
                    }
                    jQuery('span.total').text(response.total);
                    jQuery('span.discount').text(response.discount);
                    jQuery('a.sign.cart_info span.ccount').html(response.cnt);

                    if (response.cnt == 1) {
                        jQuery('span.discount_info').html('Add another card to recieve a 10% discount on all tradelines, or two or more for a 20% discount.');
                    }
                    if (response.cnt == 2) {
                        if (jQuery('span.discount_info').length > 0) {
                            jQuery('span.discount_info').html('Add one or more card to recieve a 20% discount on all tradelines. ');
                        } else {
                            jQuery('div.right_menu').append('<span class="discount_info">Add one or more card to recieve a 20% discount on all tradelines. </span>');
                        }

                    }

                    jQuery('.entry-content').append('<div class="winwin_popup"><div class="winwin_poppup_inner">Item was remove from your cart successfully.<span class="pop_upclose">X</span></div></div>');
                }
            }
        });
        //jQuery(this).hide();            
    });


	jQuery('#upadte_sellerinfo').on('click', 'button#update_info_btn', function(e) {
		e.preventDefault();
		var ptype = jQuery('#upadte_sellerinfo').find('#ptype').val();
		var fname = jQuery('#upadte_sellerinfo').find('#fname').val();
		var lname = jQuery('#upadte_sellerinfo').find('#lname').val();
		var email = jQuery('#upadte_sellerinfo').find('#email').val();
		var pnumber = jQuery('#upadte_sellerinfo').find('#pnumber').val();
		var errors = new Array;
		if (ptype == ''){ 
            errors.push('Please select any one payment type');
            jQuery('#ptype').css('border-color', '#c22020');
		}
		if (!fname){ 
            errors.push('First name required.');
            jQuery('#fname').css('border-color', '#c22020');
		}
		if (!lname){ 
            errors.push('Last name required.');
            jQuery('#lname').css('border-color', '#c22020');
		}
		if (!email){ 
            errors.push('Email required.');
            jQuery('#email').css('border-color', '#c22020');
		}
		if (!pnumber){ 
            errors.push('Phone number required.');
            jQuery('#pnumber').css('border-color', '#c22020');
		}
		// var pdetail = [];
		if (ptype == 'PP') {
			var pname = 'PayPal';
    		var pp_email = jQuery('#upadte_sellerinfo').find('#pp_email').val();
    		if (!pp_email) {
    			errors.push('Please enter your PayPal email.');
            	jQuery('#pp_email').css('border-color', '#c22020');
    		}
            var pdetail = {pp_email: pp_email};
    		
    	}else if(ptype == 'DBT'){
    		var pname = 'Direct Bank Transfer';
    		var dbt_name = jQuery('#upadte_sellerinfo').find('#dbt_name').val();
    		var dbt_acno = jQuery('#upadte_sellerinfo').find('#dbt_acno').val();
    		var dbt_brno = jQuery('#upadte_sellerinfo').find('#dbt_brno').val();
    		if (!dbt_name) {
    			errors.push('Please enter your bank name.');
            	jQuery('#dbt_name').css('border-color', '#c22020');
    		}
    		if (!dbt_acno) {
    			errors.push('Please enter your bank account number');
            	jQuery('#dbt_acno').css('border-color', '#c22020');
    		}
    		if (!dbt_brno) {
    			errors.push('Please enter your bank routing number.');
            	jQuery('#dbt_brno').css('border-color', '#c22020');
    		}
            var pdetail = {dbt_name: dbt_name, dbt_acno: dbt_acno, dbt_brno: dbt_brno};
    	}else if(ptype == 'MPC'){
    		var pname = 'Mail Paper Check';
    		var mpc_address = jQuery('#upadte_sellerinfo').find('#mpc_address').val();
    		if (!mpc_address) {
    			errors.push('Please enter your full address.');
            	jQuery('#mpc_address').css('border-color', '#c22020');
    		}
            var pdetail = {mpc_address: mpc_address};
    	}
		if (errors.length == 0) {
            
            pdetail = JSON.stringify(pdetail);
            
	    	jQuery.ajax({
                url: winwin_object.winwin_ajax_url,
                type: 'post',
                dataType: "json",
                data: {
                    action: 'update_sellerinfo',
                    //slcb : slcb, 
                    fname: fname,
                    lname: lname,
                    email: email,
                    pnumber: pnumber,
                    ptype: ptype,
                    pname: pname,
                    pdetail: pdetail
                },
                success: function(response) {
                    // alert('1243');
                    // alert(response);
                    // jQuery('#credlimit').prop('disabled', 'disabled');
                    // jQuery('#yearcard').prop('disabled', 'disabled');
                    // jQuery('#monthcard').prop('disabled', 'disabled');
                    // jQuery('#stmntday').prop('disabled', 'disabled');
                    // jQuery('#lessten').prop('disabled', 'disabled');
                    jQuery('#payment-alert').html(response);
                }
            });

		}
		



	});

    jQuery('#upadte_sellerinfo').on('change', 'select#ptype', function(e) {
    	var ptype = jQuery('#ptype').val();
    	if (ptype == 'PP') {
    		jQuery('.pp_block').show();
    		jQuery('.dbt_block').hide();
    		jQuery('.mpc_block').hide();
    	}else if(ptype == 'DBT'){
    		jQuery('.pp_block').hide();
    		jQuery('.dbt_block').show();
    		jQuery('.mpc_block').hide();
    	}else if(ptype == 'MPC'){
    		jQuery('.pp_block').hide();
    		jQuery('.dbt_block').hide();
    		jQuery('.mpc_block').show();
    	}else{
    		jQuery('.pp_block').hide();
    		jQuery('.dbt_block').hide();
    		jQuery('.mpc_block').hide();
    	}
        // var scrolled = 0;
        // jQuery('#update_info').show();
        // jQuery('html, body').scrollTop(jQuery('#seller_credit_form').offset().top);
    });

    jQuery('#inventory_seller_list').on('click', 'button.add_card', function(e) {
        var scrolled = 0;
        jQuery('#seller_credit_form').show();
        jQuery('html, body').scrollTop(jQuery('#seller_credit_form').offset().top);
    });
     jQuery('#tab3default').on('click', 'button.update_info', function(e) {
        var scrolled = 0;
        jQuery('#update_info').show();
        jQuery('html, body').scrollTop(jQuery('#seller_credit_form').offset().top);
    });
     jQuery('.entry-content').on('click', '#update_info .remove_add', function(e) {
        e.preventDefault();
        jQuery('#update_info').hide();
    });

    jQuery('#seller_credit_form').on('click', 'button#checkcommi', function(e) {
        e.preventDefault();
        jQuery('#seller_credit_form input, #seller_credit_form select').css('border-color', '#CCCCCC');
        jQuery('#card_disqualify').remove();
        console.log('commision click working');
        var errors = new Array;
        //var sfn = jQuery('#seller_fname').val(); 
        // var sln = jQuery('#seller_lname').val();    
        //var slcb = jQuery('#cc_balance').val();
        var slcl = jQuery('#credlimit').val();
        var scy = jQuery('#yearcard').val();
        var scm = jQuery('#monthcard').val();
        var slcd = jQuery('#stmntday').val();
        var morfif = jQuery('#lessten').val();

        var creditor = jQuery('#creditor').val();
        var credname = jQuery('#crdtrname').val();
        var maxspots = jQuery('#maxspots').val();
        var sellingprice = jQuery('#sellingprice').val();
        var street = jQuery('#street').val();
        var city = jQuery('#city').val();
        var state = jQuery('#state').val();
        var commission = jQuery('#commission').val();
        var zip = jQuery('#zip').val();
        // errors = new Array();

        if (!creditor) {
            errors.push('This card does not qualify');
            jQuery('#creditor').css('border-color', '#c22020');
        }

        if (creditor == 'notinlist') {

            if (!credname) {

                errors.push('This card does not qualify');
                jQuery('#credname').css('border-color', '#c22020');
            }
        }

        if (!maxspots) {
            errors.push('This card does not qualify');
            jQuery('#maxspots').css('border-color', '#c22020');
        }

        if (!street) {
            errors.push('This card does not qualify');
            jQuery('#street').css('border-color', '#c22020');
        }

        if (!city) {
            errors.push('This card does not qualify');
            jQuery('#city').css('border-color', '#c22020');
        }

        if (!state) {
            errors.push('This card does not qualify');
            jQuery('#state').css('border-color', '#c22020');
        }

        if (!zip) {
            errors.push('This card does not qualify');
            jQuery('#zip').css('border-color', '#c22020');
        }

        if (morfif == 'no' || !morfif) {
            errors.push('This card does not qualify');
            jQuery('#lessten').parent().append('<span id="card_disqualify">This card does not qualify</span>');
        }
        if (!slcl) {
            errors.push('Please credit limit for validation');
            jQuery('#credlimit').css('border-color', '#c22020');
        }
        if (slcl) {
            if (slcl <= 1) {
                errors.push('Please credit limit for validation');
                jQuery('#credlimit').css('border-color', '#c22020');
            }

            if (slcl > 80000) {
                errors.push('Maximum credit limit exceeded');
                jQuery('#credlimit').css('border-color', '#c22020');
            }
        }
        if (!scy) {
            errors.push('Please atleast enter the credit limit for validation');
            jQuery('#yearcard').css('border-color', '#c22020');
        }
        if (!scm) {
            errors.push('Please atleast enter the credit limit for validation');
            jQuery('#monthcard').css('border-color', '#c22020');
        }
        if (!slcd) {
            errors.push('Please atleast enter the credit limit for validation');
            jQuery('#stmntday').css('border-color', '#c22020');
        }
        if (errors.length == 0) {
            // alert('in ajax');
            jQuery('#seller_credit_form input, #seller_credit_form select').css('border-color', '#CCCCCC');
            jQuery('#card_disqualify').remove();
            jQuery.ajax({
                url: winwin_object.winwin_ajax_url,
                type: 'post',
                data: {
                    action: 'calculate_seller_commission',
                    //slcb : slcb, 
                    slcd: slcd,
                    scm: scm,
                    scy: scy,
                    slcl: slcl
                },
                success: function(response) {
                    // alert('1243');
                    jQuery('#credlimit').prop('disabled', 'disabled');
                    jQuery('#yearcard').prop('disabled', 'disabled');
                    jQuery('#monthcard').prop('disabled', 'disabled');
                    jQuery('#stmntday').prop('disabled', 'disabled');
                    jQuery('#lessten').prop('disabled', 'disabled');
                    jQuery('#card_proced_content').html(response.html);
                }
            });
        }
        //jQuery(this).hide();            
    });
    jQuery('.entry-content').on('click', '#seller_card_edit_form button#checkeditcommi', function(e) {
        e.preventDefault();
        jQuery('#card_edit_disqualify').remove();
        jQuery('#seller_card_edit_form input, #seller_card_edit_form select').css('border-color', '#CCCCCC');
        console.log('commision edit click working');
        var errors = new Array;
        var slcl = jQuery('#credlimit_edit').val();
        var scy = jQuery('#yearcard_edit').val();
        var scm = jQuery('#monthcard_edit').val();
        var slcd = jQuery('#stmntday_edit').val();
        var morfif = jQuery('#lessten_edit').val();

        var creditor = jQuery('#creditor_edit').val();
        var credname = jQuery('#crdtrname_edit').val();

        var maxspots = jQuery('#maxspots_edit').val();
        var sellingprice = jQuery('#card_edit_proced_content #sellingprice').val();
        var street = jQuery('#street_edit').val();
        var city = jQuery('#city_edit').val();
        var state = jQuery('#state_edit').val();
        var commission = jQuery('#card_edit_proced_content #commission').val();
        var zip = jQuery('#zip_edit').val();


        if (!creditor) {
            errors.push('This card does not qualify');
            jQuery('#creditor_edit').css('border-color', '#c22020');
        }

        if (creditor == 'notinlist') {

            if (!credname) {

                errors.push('This card does not qualify');
                jQuery('#credname_edit').css('border-color', '#c22020');
            }
        }

        if (!maxspots) {
            errors.push('This card does not qualify');
            jQuery('#maxspots_edit').css('border-color', '#c22020');
        }

        if (!street) {
            errors.push('This card does not qualify');
            jQuery('#street_edit').css('border-color', '#c22020');
        }

        if (!city) {
            errors.push('This card does not qualify');
            jQuery('#city_edit').css('border-color', '#c22020');
        }

        if (!state) {
            errors.push('This card does not qualify');
            jQuery('#state_edit').css('border-color', '#c22020');
        }

        if (!zip) {
            errors.push('This card does not qualify');
            jQuery('#zip_edit').css('border-color', '#c22020');
        }

        if (morfif == 'no' || !morfif) {
            errors.push('This card does not qualify');
            jQuery('#lessten_edit').parent().append('<span id="card_edit_disqualify">This card does not qualify</span>');
        }
        if (!slcl) {
            errors.push('Please credit limit for validation');
            jQuery('#credlimit_edit').css('border-color', '#c22020');
        }
        if (slcl) {
            if (slcl <= 1) {
                errors.push('Please credit limit for validation');
                jQuery('#credlimit_edit').css('border-color', '#c22020');
            }

            if (slcl > 80000) {
                errors.push('Maximum credit limit exceeded');
                jQuery('#credlimit_edit').css('border-color', '#c22020');
            }
        }
        if (!scy) {
            errors.push('Please atleast enter the credit limit for validation');
            jQuery('#yearcard_edit').css('border-color', '#c22020');
        }
        if (!scm) {
            errors.push('Please atleast enter the credit limit for validation');
            jQuery('#monthcard_edit').css('border-color', '#c22020');
        }
        if (!slcd) {
            errors.push('Please atleast enter the credit limit for validation');
            jQuery('#stmntday_edit').css('border-color', '#c22020');
        }
        if (errors.length == 0) {
            jQuery('#seller_card_edit_form input, #seller_card_edit_form select').css('border-color', '#CCCCCC');
            jQuery('#card_edit_disqualify').remove();
            jQuery.ajax({
                url: winwin_object.winwin_ajax_url,
                type: 'post',
                data: {
                    action: 'calculate_seller_commission',
                    //slcb : slcb, slcl : slcl, slscd : slscd, slca: slca  
                    slcd: slcd,
                    scm: scm,
                    scy: scy,
                    slcl: slcl
                },
                success: function(response) {
                    jQuery('#credlimit_edit').prop('disabled', 'disabled');
                    jQuery('#yearcard_edit').prop('disabled', 'disabled');
                    jQuery('#monthcard_edit').prop('disabled', 'disabled');
                    jQuery('#stmntday_edit').prop('disabled', 'disabled');
                    jQuery('#lessten_edit').prop('disabled', 'disabled');
                    jQuery('#card_edit_proced_content').html(response.html);
                }
            });
        }
        //jQuery(this).hide();            
    });
    jQuery('#card_proced_content').on('click', 'input#card_submit', function(e) {
        e.preventDefault();
        jQuery('#seller_credit_form input, #seller_credit_form select').css('border-color', '#CCCCCC');
        jQuery('#card_disqualify').remove();
        var creditor = jQuery('#creditor').val();
        var credname = jQuery('#crdtrname').val();
        var credlimit = jQuery('#credlimit').val();
        var lessten = jQuery('#lessten').val();
        var yearcard = jQuery('#yearcard').val();
        var monthcard = jQuery('#monthcard').val();
        var stmntday = jQuery('#stmntday').val();
        var maxspots = jQuery('#maxspots').val();
        var sellingprice = jQuery('#sellingprice').val();
        var street = jQuery('#street').val();
        var city = jQuery('#city').val();
        var state = jQuery('#state').val();
        var commission = jQuery('#commission').val();
        var zip = jQuery('#zip').val();
        errors = new Array();

        if (!creditor) {
            errors.push('This card does not qualify');
            jQuery('#creditor').css('border-color', '#c22020');
        }

        if (creditor == 'notinlist') {

            if (!credname) {

                errors.push('This card does not qualify');
                jQuery('#credname').css('border-color', '#c22020');
            }
        }

        if (!maxspots) {
            errors.push('This card does not qualify');
            jQuery('#maxspots').css('border-color', '#c22020');
        }

        if (!street) {
            errors.push('This card does not qualify');
            jQuery('#street').css('border-color', '#c22020');
        }

        if (!city) {
            errors.push('This card does not qualify');
            jQuery('#city').css('border-color', '#c22020');
        }

        if (!state) {
            errors.push('This card does not qualify');
            jQuery('#state').css('border-color', '#c22020');
        }

        if (!zip) {
            errors.push('This card does not qualify');
            jQuery('#zip').css('border-color', '#c22020');
        }

        if (lessten == 'no') {
            errors.push('This card does not qualify');
            jQuery('#lessten').parent().append('<span id="card_disqualify">This card does not qualify</span>');
        }
        if (errors.length == 0) {
            jQuery.ajax({
                url: winwin_object.winwin_ajax_url,
                type: 'post',
                data: {
                    action: 'seller_add_card',
                    creditor: creditor,
                    credname: credname,
                    credlimit: credlimit,
                    lessten: lessten,
                    monthcard: monthcard,
                    yearcard: yearcard,
                    stmntday: stmntday,
                    maxspots: maxspots,
                    sellingprice: sellingprice,
                    street: street,
                    city: city,
                    state: state,
                    commission: commission,
                    zip: zip
                },
                success: function(response) {
                    console.log('success working');
                    jQuery('#submit_message').html(response.html);
                    jQuery('#card_proced_content').html('<button id="checkcommi" class="btn btn-primary" type="submit">Next</button>');
                    jQuery('#credlimit').prop('disabled', false);
                    jQuery('#yearcard').prop('disabled', false);
                    jQuery('#monthcard').prop('disabled', false);
                    jQuery('#stmntday').prop('disabled', false);
                    jQuery('#lessten').prop('disabled', false);
                    jQuery('#add_seller_inventory')[0].reset();
                }
            });
        }
    });
    jQuery('.entry-content').on('click', '#card_edit_proced_content input#card_submit', function(e) {
        e.preventDefault();
        var creditor = jQuery('#creditor_edit').val();
        var credname = jQuery('#crdtrname_edit').val();
        var credlimit = jQuery('#credlimit_edit').val();
        var lessten = jQuery('#lessten_edit').val();
        var yearcard = jQuery('#yearcard_edit').val();
        var monthcard = jQuery('#monthcard_edit').val();
        var stmntday = jQuery('#stmntday_edit').val();
        var maxspots = jQuery('#maxspots_edit').val();
        var sellingprice = jQuery('#card_edit_proced_content #sellingprice').val();
        var street = jQuery('#street_edit').val();
        var city = jQuery('#city_edit').val();
        var state = jQuery('#state_edit').val();
        var commission = jQuery('#card_edit_proced_content #commission').val();
        var zip = jQuery('#zip_edit').val();
        var rowid = jQuery('#row_db_edit').val();
        errors = new Array();
        if (!creditor || !credlimit || !lessten || !monthcard || !yearcard || !stmntday || !maxspots || !sellingprice || !street || !city || !state || !commission || !zip) {
            errors.push('All fields are required');
            jQuery('#seller_card_edit_form #submit_message').html('<span style="color:#c22020">All fields are required</span>');
        }
        if (errors.length == 0) {
            jQuery.ajax({
                url: winwin_object.winwin_ajax_url,
                type: 'post',
                data: {
                    action: 'seller_card_edit_save',
                    creditor: creditor,
                    credname: credname,
                    credlimit: credlimit,
                    lessten: lessten,
                    monthcard: monthcard,
                    yearcard: yearcard,
                    stmntday: stmntday,
                    maxspots: maxspots,
                    sellingprice: sellingprice,
                    street: street,
                    city: city,
                    state: state,
                    commission: commission,
                    zip: zip,
                    rowid: rowid
                },
                success: function(response) {
                    console.log('edit success working');
                    if (response.a == 'yes') {
                        jQuery('.entry-content').append(response.html);
                        jQuery('.entry-content #seller_card_edit_form').remove();
                        jQuery('button.card_edit').removeClass('busy');
                    } else {
                        jQuery('.entry-content #edit_seller_inventory #submit_message').html(response.html);
                    }
                }
            });
        }
    });
    jQuery('.entry-content').on('click', '#card_edit_proced_content input.card_reset', function(e) {

        jQuery('#credlimit_edit').prop('disabled', false);
        jQuery('#yearcard_edit').prop('disabled', false);
        jQuery('#monthcard_edit').prop('disabled', false);
        jQuery('#stmntday_edit').prop('disabled', false);
        jQuery('#lessten_edit').prop('disabled', false);
        jQuery('#card_edit_proced_content').html('<span style="color:#c22020;">This is the maximum fee allowed on this card, if you would like to accept please continue </span><button id="checkeditcommi" class="btn btn-primary">Next</button>');
    });
    jQuery('.entry-content').on('click', '#card_proced_content input.card_reset', function(e) {
        jQuery('#credlimit').prop('disabled', false);
        jQuery('#yearcard').prop('disabled', false);
        jQuery('#monthcard').prop('disabled', false);
        jQuery('#stmntday').prop('disabled', false);
        jQuery('#lessten').prop('disabled', false);
        jQuery('#card_proced_content').html('<span style="color:#c22020;">This is the maximum fee allowed on this card, if you would like to accept please continue </span><button id="checkcommi" class="btn btn-primary">Next</button>');
    });
    jQuery('#inventory_seller_list').on('click', 'button.card_edit', function(e) {
        e.preventDefault();
        var cid = jQuery(this).data('id');
        var uid = jQuery(this).data('uid');
        if (!jQuery(this).hasClass('busy')) {
            jQuery('button.card_edit').addClass('busy');
            jQuery.ajax({
                url: winwin_object.winwin_ajax_url,
                type: 'post',
                data: {
                    action: 'seller_card_edit',
                    cid: cid,
                    uid: uid
                },
                success: function(response) {
                    console.log('success working');
                    jQuery('#inventory_seller_list').prepend(response.html);
                    jQuery('html, body').scrollTop(jQuery('#seller_card_edit_form').offset().top);
                }
            });
        } else {
            alert('You are already Editing a Card Please complete or remove to open another');
            jQuery('html, body').scrollTop(jQuery('#seller_card_edit_form').offset().top);
        }
    });
    jQuery('#inventory_seller_list').on('click', 'button.card_delete', function(e) {
        e.preventDefault();
        var cid = jQuery(this).data('id');
        var uid = jQuery(this).data('uid');
        jQuery.ajax({
            url: winwin_object.winwin_ajax_url,
            type: 'post',
            data: {
                action: 'seller_delete_card',
                cid: cid,
                uid: uid
            },
            success: function(response) {
                console.log('success working');
                jQuery('#inventory_seller_list').append(response.html);
                jQuery('#sell_card' + cid + '').fadeOut(400);
            }
        });
    });
    jQuery('.entry-content').on('click', '.pop_upclose', function(e) {
        var redir = jQuery(this).data('redir');
        jQuery('.winwin_popup').remove();
        if (redir) {
            window.location.href = redir;
        }
        //jQuery(this).hide();            
    });
    jQuery('.entry-content').on('click', '#seller_card_edit_form .remove_edit', function(e) {
        e.preventDefault();
        jQuery('button.card_edit').removeClass('busy');
        jQuery('#seller_card_edit_form').remove();
    });

    jQuery('.entry-content').on('click', '#seller_credit_form .remove_add', function(e) {
        e.preventDefault();
        jQuery('#seller_credit_form').hide();
    });
    jQuery('#seller_credit_form').on('change', 'select#creditor', function() {
        var cd = jQuery(this).val();
        if (cd == 'notinlist') {
            jQuery('#othercname').show();
            jQuery('#crdtrname').val('');
            if (jQuery('#cname_space_adjust').hasClass('col-lg-6') && jQuery('#cname_space_adjust').hasClass('col-md-6')) {
                jQuery('#cname_space_adju').removeClass('col-lg-3').addClass('col-lg-2').removeClass('col-md-3').addClass('col-md-2');
                jQuery('#cname_space_adjust').removeClass('col-lg-6').addClass('col-lg-4').removeClass('col-md-6').addClass('col-md-4');
                //jQuery('#cname_space_adjust').find('label').addClass('label-fsize-adjust');
            }
        } else {
            jQuery('#crdtrname').val(jQuery(this).children(':selected').text());
            jQuery('#othercname').hide();
            if (jQuery('#cname_space_adjust').hasClass('col-lg-4') && jQuery('#cname_space_adjust').hasClass('col-md-4')) {
                jQuery('#cname_space_adju').removeClass('col-lg-2').addClass('col-lg-3').removeClass('col-md-2').addClass('col-md-3');
                jQuery('#cname_space_adjust').removeClass('col-lg-4').addClass('col-lg-6').removeClass('col-md-4').addClass('col-md-6');
                //jQuery('#cname_space_adjust').find('label').removeClass('label-fsize-adjust');
            }
        }
    });
    jQuery('.entry-content').on('change', '#seller_card_edit_form select#creditor_edit', function() {
        var cd = jQuery(this).val();
        if (cd == 'notinlist') {
            jQuery('#othercname_edit').show();
            jQuery('#crdtrname_edit').val('');
            if (jQuery('#cname_space_adjust_edit').hasClass('col-lg-6') && jQuery('#cname_space_adjust_edit').hasClass('col-md-6')) {
                jQuery('#othercrt_edit').removeClass('col-sm-3').addClass('col-sm-2');
                jQuery('#cname_space_adju_edit').removeClass('col-lg-3').addClass('col-lg-2').removeClass('col-md-3').addClass('col-md-2').removeClass('col-sm-3').addClass('col-sm-2');
                jQuery('#cname_space_adjust_edit').removeClass('col-lg-6').addClass('col-lg-4').removeClass('col-md-6').addClass('col-md-4').removeClass('col-sm-6').addClass('col-sm-5');
                //jQuery('#cname_space_adjust').find('label').addClass('label-fsize-adjust');
            }
        } else {
            jQuery('#crdtrname_edit').val(jQuery(this).children(':selected').text());
            jQuery('#othercname_edit').hide();
            jQuery('#othercrt_edit').removeClass('col-sm-2').addClass('col-sm-3');
            jQuery('#cname_space_adju_edit').removeClass('col-lg-2').addClass('col-lg-3').removeClass('col-md-2').addClass('col-md-3').removeClass('col-sm-2').addClass('col-sm-3');
            jQuery('#cname_space_adjust_edit').removeClass('col-lg-4').addClass('col-lg-6').removeClass('col-md-4').addClass('col-md-6').removeClass('col-sm-5').addClass('col-sm-6');
        }
    });
    jQuery(".winwintooltip").hover(function() {
        jQuery(this).parent().parent().find('small').fadeIn(100);
    }, function() {
        jQuery(this).parent().parent().find('small').fadeOut(500);
    });

    jQuery('.lndinfo').on('click', 'input.add_more', function(e) {
        var ac = jQuery('#address_count').val();
        if (ac == 1) {
            jQuery('.lndlord_section2').show();
            jQuery('.remove_more').show();
            jQuery('#address_count').val(2);
        }

        if (ac == 2) {
            jQuery('.lndlord_section3').show();
            jQuery('#address_count').val(3);
            jQuery('.add_more').hide();
        }
    });
    jQuery('.lndinfo').on('click', 'input.remove_more', function(e) {
        var ac = jQuery('#address_count').val();
        if (ac == 3) {
            jQuery('.lndlord_section3').hide();
            jQuery('#address_count').val(2);
            jQuery('.add_more').show();
        }

        if (ac == 2) {
            jQuery('.lndlord_section2').hide();
            jQuery('.remove_more').hide();
            jQuery('#address_count').val(1);
        }
    });

   

    jQuery('#payment_type').change(function() {

        var ac = jQuery('#address_count').val();
        var pt = jQuery(this).val();
        var pto = 0;
        var adt = '';

        if (pt == 'monthly') {
            if (ac != 1) {

                if (ac == 2) {
                    adt = '($40 for One additional landlord)';
                    pto = 69.99;
                }
                if (ac == 3) {
                    adt = '($40 + $30 for two additional landlords)';
                    pto = 99.99;
                }
            } else {
                pto = 29.99;
            }

            jQuery('#payment_notice').html('The rental tradlines will have a $29.99 as a setup fee ' + adt + ' and $9.99 per month.');
            jQuery('#payment_total').html('Total: <span>$' + pto + '</span> (One time) + $9.99/month.');
        } else if (pt == 'yearly') {

            if (ac != 1) {

                if (ac == 2) {
                    adt = '($40 for One additional landlord)';
                    pto = 141.92;
                }
                if (ac == 3) {
                    adt = '($40 + $30 for two additional landlords)';
                    pto = 171.29;
                }
            } else {
                pto = 101.92;
            }

            jQuery('#payment_notice').html('The rental tradlines will have a $29.99 as a setup fee ' + adt + ' and 40% discount for the yearly cost of ($71.93) for the 12 months (This would not be auto-renewed)');
            jQuery('#payment_total').html('Total: <span>$' + pto + '</span> (One time for 12 months, which would not be auto-renewed)');
        } else {
            jQuery('#payment_notice').html('Please choose payment method to calculate the total payment cost.');
            jQuery('#payment_total').html('');
        }



    });
     $("#resend").click(function() {
        var a = jQuery('#resend').data("id");
        var b = jQuery('#resend').data("rdata");
        jQuery.ajax({
                    url: winwin_object.winwin_ajax_url,
                    type: 'post',
                    data: {
                        action: 'resend_conf',
                        a: a,
                        b: b
                    },
                    success: function(response) {
                        alert('Confirmation link resend in your email.');
                    }
                });
     });

    //jQuery time
    var current_fs, next_fs, previous_fs; //fieldsets
    var left, opacity, scale; //fieldset properties which we will animate
    var animating; //flag to prevent quick multi-click glitches
    $(".next").click(function() {
        if (animating) return false;
        validate = new Array;
        current_fs = $(this).parent();
        next_fs = $(this).parent().next();
        if (current_fs.hasClass('lndregister')) {
            jQuery('.lndregister input, .lndregister select').css('border-color', '#CCCCCC');
            var a = jQuery('#lnd_fname').val();
            var b = jQuery('#lnd_mname').val();
            var c = jQuery('#lnd_lname').val();
            var d = jQuery('#lnd_ssn').val();
            var e = jQuery('#lnd_cssn').val();
            var f = jQuery('#lnd_dob').val();
            var g = jQuery('#lnd_phone').val();
            var h = jQuery('#lnd_street').val();
            var i = jQuery('#lnd_aptunit').val();
            var j = jQuery('#lnd_city').val();
            var k = jQuery('#lnd_state').val();
            var l = jQuery('#lnd_zip').val();
            var m = jQuery('#lnd_email').val();
            var n = jQuery('#lnd_pass').val();
            var o = jQuery('#lnd_rpass').val();
            var p = jQuery('#new_user').val();
            validate = validtion_reg(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p);
            console.log(validate);
            console.log(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p);
            if (validate.length == 0) {
                jQuery.ajax({
                    url: winwin_object.winwin_ajax_url,
                    type: 'post',
                    data: {
                        action: 'lnd_registration',
                        a: a,
                        b: b,
                        c: c,
                        d: d,
                        e: e,
                        f: f,
                        g: g,
                        h: h,
                        i: i,
                        j: j,
                        k: k,
                        l: l,
                        m: m,
                        n: n,
                        o: o
                    },
                    success: function(response) {
                        // alert(response.uid+'=='+response.rdata);
                        // jQuery('.entry-content').append(response.html); 
                        $("#resend").attr("data-id", response.uid);
                        $("#resend").attr("data-rdata", response.rdata);
                        animating = true;
                        //activate next step on progressbar using the index of next_fs
                        $("#progressbar li").eq($("fieldset").index(next_fs)).addClass("active");
                        //show the next fieldset
                        next_fs.show();
                        //hide the current fieldset with style
                        current_fs.animate({
                            opacity: 0
                        }, {
                            step: function(now, mx) {
                                //as the opacity of current_fs reduces to 0 - stored in "now"
                                //1. scale current_fs down to 80%
                                scale = 1 - (1 - now) * 0.2;
                                //2. bring next_fs from the right(50%)
                                left = (now * 50) + "%";
                                //3. increase opacity of next_fs to 1 as it moves in
                                opacity = 1 - now;
                                current_fs.css({
                                    'transform': 'scale(' + scale + ')',
                                    'position': 'relative'
                                });
                                next_fs.css({
                                    'left': left,
                                    'opacity': opacity
                                });
                            },
                            duration: 800,
                            complete: function() {
                                current_fs.hide();
                                animating = false;
                            }
                        });
                    }
                });
            }
        } else if (current_fs.hasClass('lndinfo')) {
            jQuery('.lndinfo input, .lndinfo select').css('border-color', '#CCCCCC');
            var ac = jQuery('#address_count').val();

            validate = validation_info(ac);
            if (validate.length == 0) {
                jQuery('#payment_type').trigger('change');
                animating = true;
                //activate next step on progressbar using the index of next_fs
                $("#progressbar li").eq($("fieldset").index(next_fs)).addClass("active");
                //show the next fieldset
                next_fs.show();
                //hide the current fieldset with style
                current_fs.animate({
                    opacity: 0
                }, {
                    step: function(now, mx) {
                        //as the opacity of current_fs reduces to 0 - stored in "now"
                        //1. scale current_fs down to 80%
                        scale = 1 - (1 - now) * 0.2;
                        //2. bring next_fs from the right(50%)
                        left = (now * 50) + "%";
                        //3. increase opacity of next_fs to 1 as it moves in
                        opacity = 1 - now;
                        current_fs.css({
                            'transform': 'scale(' + scale + ')',
                            'position': 'relative'
                        });
                        next_fs.css({
                            'left': left,
                            'opacity': opacity
                        });
                    },
                    duration: 800,
                    complete: function() {
                        current_fs.hide();
                        animating = false;
                    }
                });
            }
        } else {
            animating = true;
            //activate next step on progressbar using the index of next_fs
            $("#progressbar li").eq($("fieldset").index(next_fs)).addClass("active");
            //show the next fieldset
            next_fs.show();
            //hide the current fieldset with style
            current_fs.animate({
                opacity: 0
            }, {
                step: function(now, mx) {
                    //as the opacity of current_fs reduces to 0 - stored in "now"
                    //1. scale current_fs down to 80%
                    scale = 1 - (1 - now) * 0.2;
                    //2. bring next_fs from the right(50%)
                    left = (now * 50) + "%";
                    //3. increase opacity of next_fs to 1 as it moves in
                    opacity = 1 - now;
                    current_fs.css({
                        'transform': 'scale(' + scale + ')',
                        'position': 'relative'
                    });
                    next_fs.css({
                        'left': left,
                        'opacity': opacity
                    });
                },
                duration: 800,
                complete: function() {
                    current_fs.hide();
                    animating = false;
                }
            });
        }
    });
// jQuery('').on('click', 'ul li ', function(e) {
    
// }
$("a.li-click").click(function() {
     var tradeid = this.id;
     var tradelineid =$(this).data('tid');
     // alert(tradelineid);
     jQuery.ajax({
                url: winwin_object.winwin_ajax_url,
                type: 'post',
                data: {
                    action: 'seller_noti_update',
                    //slcb : slcb, 
                    tid: tradelineid
                },
                success: function(response) {
                    // alert(response);
                    if (response == 0) {
                        $('#total-noti-tab').remove();
                        $('.noti-det').remove();
                    }else{
                        $('#total-noti').html(response);
                        $('#total-noti-tab').html(response);
                    }
                    $('#notiid'+tradeid).remove();
                    
                    // jQuery('#autitle').prop('disabled', 'disabled');
                    // jQuery('#yearcard').prop('disabled', 'disabled');
                    // jQuery('#submit_message_au').html(response.html);
                }
            });
});
    $(".previous").click(function() {
        if (animating) return false;
        animating = true;
        current_fs = $(this).parent();
        previous_fs = $(this).parent().prev();
        //de-activate current step on progressbar
        $("#progressbar li").eq($("fieldset").index(current_fs)).removeClass("active");
        //show the previous fieldset
        previous_fs.show();
        //hide the current fieldset with style
        current_fs.animate({
            opacity: 0
        }, {
            step: function(now, mx) {
                //as the opacity of current_fs reduces to 0 - stored in "now"
                //1. scale previous_fs from 80% to 100%
                scale = 0.8 + (1 - now) * 0.2;
                //2. take current_fs to the right(50%) - from 0%
                left = ((1 - now) * 50) + "%";
                //3. increase opacity of previous_fs to 1 as it moves in
                opacity = 1 - now;
                current_fs.css({
                    'left': left
                });
                previous_fs.css({
                    'transform': 'scale(' + scale + ')',
                    'opacity': opacity
                });
            },
            duration: 800,
            complete: function() {
                current_fs.hide();
                animating = false;
            }
        });
    });
// jQuery('#winwin_payment').on('click', 'button#submit-payment', function(e) {
//         alert('1');
//         e.preventDefault();
//         var ptype = jQuery('input[name=payment_type]:checked').val();
//         jQuery.ajax({
//             url: winwin_object.winwin_ajax_url,
//             type: 'post',
//             data: {
//                 action: 'winwin_payment_post',
//                 payment_type: ptype

//             },
//             success: function(response) {
//                 alert(response);
//                 // jQuery('.temp_waiting').remove();
//                 // jQuery(myForm).css('opacity', '1');
//                 // jQuery('.entry-content').append(response.html);
//                 // if (response.dbstat == 'Success') {
//                 //     document.location.href = response.redirect;
//                 // }

//             }
//         });
// });li-click

    jQuery('#winwin_cart').on('click', 'button.winwin_checkout', function(e) {
        // alert('1');
        e.preventDefault();
        //console.log('chekout link click working')
        jQuery('#winwin_cart input, #winwin_cart select').css('border-color', '#CCCCCC');
        var errors = new Array;
        var order_id = jQuery(this).data('id');
        var total = jQuery('span.total').text();
        var fname = jQuery('#fname').val();
        var lname = jQuery('#lname').val();
        var street = jQuery('#street').val();
        var state = jQuery('#state').val();
        var city = jQuery('#city').val();
        var zip = jQuery('#zip').val();
        var email = jQuery('#bemail').val();
        var phone = jQuery('#phone').val();
        var altphone = jQuery('#altphone').val();
        var ssn = jQuery('#ssn').val();
        var legalstatus = jQuery('#legal_status').val();
        var dob = jQuery('#dob').val();
        var ccku = jQuery('#cckuname').val();
        var cckp = jQuery('#cckpass').val();
        var tssn = jQuery('#truessn').is(':checked');
        // var payment = jQuery('input[name=payment]:checked').val();
        var payment = jQuery('#payment').val();
        // break this;
        var ccNo = jQuery("#ccNo").val();
        var cvv = jQuery("#cvv").val();
        var expMonth = jQuery("#expMonth").val();
        var expYear = jQuery("#expYear").val();
        var terms = jQuery("#terms").is(':checked');
        if (!fname) {
            errors.push('Please enter the first name12');
            jQuery('#fname').css('border-color', '#c22020')
        }
        if (!lname) {
            errors.push('Please enter the first name11');
            jQuery('#lname').css('border-color', '#c22020')
        }
        if (!street) {
            errors.push('Please enter the first name10');
            jQuery('#street').css('border-color', '#c22020')
        }
        if (!state) {
            errors.push('Please enter the first name9');
            jQuery('#state').css('border-color', '#c22020')
        }
        if (!city) {
            errors.push('Please enter the first name8');
            jQuery('#city').css('border-color', '#c22020')
        }
        if (!zip) {
            errors.push('Please enter the first name7');
            jQuery('#zip').css('border-color', '#c22020')
        }
        if (!email) {
            errors.push('Please enter the first name6');
            jQuery('#bemail').css('border-color', '#c22020')
        }
        if (!phone) {
            errors.push('Please enter the first name5');
            jQuery('#phone').css('border-color', '#c22020')
        }
        if (!altphone) {
            errors.push('Please enter the first name4');
            jQuery('#altphone').css('border-color', '#c22020')
        }
        if (!ssn) {
            errors.push('Please enter the first name3');
            jQuery('#ssn').css('border-color', '#c22020')
        }
        if (!legalstatus) {
            errors.push('Please enter the first name2');
            jQuery('#legal_status').css('border-color', '#c22020')
        }
        if (!dob) {
            errors.push('Please enter the first name 1');
            jQuery('#dob').css('border-color', '#c22020')
        }
        if (dob) {
            if (birthdaycheck(dob) == false) {
                jQuery('#dob').css('border-color', '#c22020');
                errors.push('Please enter DOB');
            }
        }

        if (!ccku) {
            errors.push('Please enter the first name 1');
            jQuery('#cckuname').css('border-color', '#c22020')
        }
        if (!cckp) {
            errors.push('Please enter the first name 1');
            jQuery('#cckpass').css('border-color', '#c22020')
        }

        if (!tssn) {
            errors.push('Please ensure you have the correct SSN');
            jQuery('#truessn').parent().fadeOut('500').fadeIn();
        }
        if (!terms) {
            errors.push('Please Accept terms and conditions');
            jQuery('#terms').parent().fadeOut(500).fadeIn(1000);
        }
        if (!ccNo) {
            errors.push('Please accept terms and conditions');
            jQuery("#ccNo").css('border-color', '#c22020');
        }
        if (!cvv) {
            errors.push('Please cvv');
            jQuery("#cvv").css('border-color', '#c22020');
        }
        if (!expMonth) {
            errors.push('Please month');
            jQuery("#expMonth").css('border-color', '#c22020');
        }
        if (!expYear) {
            errors.push('Please enter year');
            jQuery("#expYear").css('border-color', '#c22020');
        }
        if (errors.length == 0) {
            if (payment == 'stripe') {
                // alert('strpe');
                stripeTokenRequest();
            }else if(payment == '2checkout'){
                // alert('2checkout');
                tokenRequestc();
            }
            
        }
        //jQuery(this).hide();   
        console.log(errors);
    });
    TCO.loadPubKey('sandbox');
    jQuery("#msform").submit(function(e) {
        // Call our token request function
        //alert('123');
        jQuery('.rentalcheckout input, .rentalcheckout select').css('border-color', '#CCCCCC');
        errors = new Array();
        var typ = jQuery("#payment_type").val();
        // var plan = jQuery("#plan").is(':checked');
        var plan = jQuery('input[name=plan]:checked').val();
        // alert(plan);
        var terms = jQuery("#terms").is(':checked');
        var ccNo = jQuery("#ccNo").val();
        var cvv = jQuery("#cvv").val();
        var expMonth = jQuery("#expMonth").val();
        var expYear = jQuery("#expYear").val();
        if (!typ) {
            errors.push('Please accept terms and conditions');
            jQuery("#payment_type").css('border-color', '#c22020');
        }
        if (!plan) {
            errors.push('Please choose any one subscription plan');
            jQuery("#payment_type").css('border-color', '#c22020');
        }
        
        if (!terms) {
            errors.push('Please accept terms and conditions');
            jQuery('#terms').parent().fadeOut(500).fadeIn(1000);
        }
        if (!ccNo) {
            errors.push('Please accept terms and conditions');
            jQuery("#ccNo").css('border-color', '#c22020');
        }
        if (!cvv) {
            errors.push('Please cvv');
            jQuery("#cvv").css('border-color', '#c22020');
        }
        if (!expMonth) {
            errors.push('Please month');
            jQuery("#expMonth").css('border-color', '#c22020');
        }
        if (!expYear) {
            errors.push('Please enter year');
            jQuery("#expYear").css('border-color', '#c22020');
        }
        if (errors.length == 0) {
            // alert('1');
            if (typ == 'stripe') {
                // alert(plan);
                stripeTokenRequestRA();
            }else if(typ == '2checkout'){
                // alert(plan);
                tokenRequest();

            }
            
        }else{
            // alert(errors.push);
        }
        // Prevent form from submitting
        return false;
    });
});

function validtion_reg(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p) {
    var errors = new Array;
    if (!a) {
        jQuery('#lnd_fname').css('border-color', '#c22020');
        errors.push('Please fill the first name');
        console.log(a);
    }
    if (!b) {
        jQuery('#lnd_mname').css('border-color', '#c22020');
        errors.push('Please fill the Middle name');
    }
    if (!c) {
        jQuery('#lnd_lname').css('border-color', '#c22020');
        errors.push('Please fill the Last name');
        console.log(c);
    }
    if (!d) {
        jQuery('#lnd_ssn').css('border-color', '#c22020');
        errors.push('Please fill ssn');
    }
    if (!e) {
        jQuery('#lnd_cssn').css('border-color', '#c22020');
        errors.push('Please confirm ssn');
    }
    if (!f) {
        jQuery('#lnd_dob').css('border-color', '#c22020');
        errors.push('Please enter DOB');
    }
    if (f) {
        if (birthdaycheck(f) == false) {
            jQuery('#lnd_dob').css('border-color', '#c22020');
            errors.push('Please enter DOB');
        }
    }

    if (!g) {
        console.log(g);
        jQuery('#lnd_phone').css('border-color', '#c22020');
        errors.push('Please enter phone number');
    }
    if (!h) {
        jQuery('#lnd_street').css('border-color', '#c22020');
        errors.push('Please enter Street address');
    }
    if (!i) {
        jQuery('#lnd_aptunit').css('border-color', '#c22020');
        errors.push('Please enter Apartment or unit address');
    }
    if (!j) {
        jQuery('#lnd_city').css('border-color', '#c22020');
        errors.push('Please enter city');
    }
    if (!k) {
        jQuery('#lnd_state').css('border-color', '#c22020');
        errors.push('Please enter state');
    }
    if (!l) {
        jQuery('#lnd_zip').css('border-color', '#c22020');
        errors.push('Please enter zip');
    }
    if (d != e) {
        jQuery('#lnd_cssn').css('border-color', '#c22020');
        errors.push('SSN do not match');
    }
    if (p == 'yes') {
        if (!m) {
            jQuery('#lnd_email').css('border-color', '#c22020');
            errors.push('Please enter an email address');
        }
        if (m && (!isValidEmailAddress(m))) {
            errors.push('Please enter a valid email address');
            jQuery('#lnd_email').css('border-color', '#c22020');
        }
        if (m && (isValidEmailAddress(m))) {
            jQuery.ajax({
                url: winwin_object.winwin_ajax_url,
                type: 'post',
                data: {
                    action: 'user_email_check',
                    email: m
                },
                success: function(response) {
                    if (response.html == 'yes') {
                        errors.push('Email already registerd');
                        jQuery('#lnd_email').css('border-color', '#c22020');
                        jQuery('#lnd_email').parent().append('<small id="username_exists" style="font-size:11px;font-style: italic;color: #c22020;float: left;line-height: 20px;margin-top: -11px;font-weight: 600;">Email already exists</small>');
                        jQuery('#username_exists').fadeOut(4000, function() {
                            jQuery(this).remove();
                        });
                    }
                }
            });
        }
        if (!n) {
            errors.push('Please enter a password');
            jQuery('#lnd_pass').css('border-color', '#c22020');
        }
        if (n && (n != o)) {
            errors.push('Password does not match');
            jQuery('#lnd_rpass').css('border-color', '#c22020');
        }
    }
    // console.log(errors);
    return errors;
}

function validation_info(ac) {



    var a = jQuery('#lndlrdname').val();
    var b = jQuery('#rstreet').val();
    var c = jQuery('#raptunit').val();
    var d = jQuery('#rcity').val();
    var e = jQuery('#rstate').val();
    var f = jQuery('#rzip').val();
    var g = jQuery('#movin').val();
    var h = jQuery('#mrent').val();

    var errors = new Array;
    if (!a) {
        jQuery('#lndlrdname').css('border-color', '#c22020');
        errors.push('Please fill the landlord name');
        console.log(a);
    }
    if (!b) {
        jQuery('#rstreet').css('border-color', '#c22020');
        errors.push('Please fill the street');
    }
    if (!c) {
        jQuery('#raptunit').css('border-color', '#c22020');
        errors.push('Please fill the aptmnt or unit');
        console.log(c);
    }
    if (!d) {
        jQuery('#rcity').css('border-color', '#c22020');
        errors.push('Please fill city');
    }
    if (!e) {
        jQuery('#rstate').css('border-color', '#c22020');
        errors.push('Please enter state');
    }
    if (!f) {
        jQuery('#rzip').css('border-color', '#c22020');
        errors.push('Please enter zip');
    }
    if (!g) {
        console.log(g);
        jQuery('#movin').css('border-color', '#c22020');
        errors.push('Please enter the Moved in date');
    }
    if (g) {
        if (yearcheck(g) == false) {
            jQuery('#movin').css('border-color', '#c22020');
            errors.push('Please enter the Moved in date');
        }
    }
    if (!h) {
        console.log(g);
        jQuery('#mrent').css('border-color', '#c22020');
        errors.push('Please enter the monthly rent');
    }


    if (ac == 2) {
        var aa = jQuery('#lndlrdname2').val();
        var bb = jQuery('#rstreet2').val();
        var cc = jQuery('#raptunit2').val();
        var dd = jQuery('#rcity2').val();
        var ee = jQuery('#rstate2').val();
        var ff = jQuery('#rzip2').val();
        var gg = jQuery('#movin2').val();
        var hh = jQuery('#mrent2').val();



        if (!aa) {
            jQuery('#lndlrdname2').css('border-color', '#c22020');
            errors.push('Please fill the landlord name');
            console.log(a);
        }
        if (!bb) {
            jQuery('#rstreet2').css('border-color', '#c22020');
            errors.push('Please fill the street');
        }
        if (!cc) {
            jQuery('#raptunit2').css('border-color', '#c22020');
            errors.push('Please fill the aptmnt or unit');
            console.log(c);
        }
        if (!dd) {
            jQuery('#rcity2').css('border-color', '#c22020');
            errors.push('Please fill city');
        }
        if (!ee) {
            jQuery('#rstate2').css('border-color', '#c22020');
            errors.push('Please enter state');
        }
        if (!ff) {
            jQuery('#rzip2').css('border-color', '#c22020');
            errors.push('Please enter zip');
        }
        if (!gg) {
            console.log(g);
            jQuery('#movin2').css('border-color', '#c22020');
            errors.push('Please enter the Moved in date');
        }
        if (gg) {
            if (yearcheck(gg) == false) {
                jQuery('#movin2').css('border-color', '#c22020');
                errors.push('Please enter the Moved in date');
            }
        }
        if (!hh) {
            console.log(g);
            jQuery('#mrent2').css('border-color', '#c22020');
            errors.push('Please enter the monthly rent');
        }


    }

    if (ac == 3) {
        var aa = jQuery('#lndlrdname2').val();
        var bb = jQuery('#rstreet2').val();
        var cc = jQuery('#raptunit2').val();
        var dd = jQuery('#rcity2').val();
        var ee = jQuery('#rstate2').val();
        var ff = jQuery('#rzip2').val();
        var gg = jQuery('#movin2').val();
        var hh = jQuery('#mrent2').val();
        var aaa = jQuery('#lndlrdname3').val();
        var bbb = jQuery('#rstreet3').val();
        var ccc = jQuery('#raptunit3').val();
        var ddd = jQuery('#rcity3').val();
        var eee = jQuery('#rstate3').val();
        var fff = jQuery('#rzip3').val();
        var ggg = jQuery('#movin3').val();
        var hhh = jQuery('#mrent3').val();

        if (!aa) {
            jQuery('#lndlrdname2').css('border-color', '#c22020');
            errors.push('Please fill the landlord name');
            console.log(aa);
        }
        if (!bb) {
            jQuery('#rstreet2').css('border-color', '#c22020');
            errors.push('Please fill the street');
        }
        if (!cc) {
            jQuery('#raptunit2').css('border-color', '#c22020');
            errors.push('Please fill the aptmnt or unit');
            console.log(c);
        }
        if (!dd) {
            jQuery('#rcity2').css('border-color', '#c22020');
            errors.push('Please fill city');
        }
        if (!ee) {
            jQuery('#rstate2').css('border-color', '#c22020');
            errors.push('Please enter state');
        }
        if (!ff) {
            jQuery('#rzip2').css('border-color', '#c22020');
            errors.push('Please enter zip');
        }
        if (!gg) {
            console.log(g);
            jQuery('#movin2').css('border-color', '#c22020');
            errors.push('Please enter the Moved in date');
        }
        if (gg) {
            if (yearcheck(gg) == false) {
                jQuery('#movin2').css('border-color', '#c22020');
                errors.push('Please enter the Moved in date');
            }
        }
        if (!hh) {
            console.log(g);
            jQuery('#mrent2').css('border-color', '#c22020');
            errors.push('Please enter the monthly rent');
        }


        if (!aaa) {
            jQuery('#lndlrdname3').css('border-color', '#c22020');
            errors.push('Please fill the landlord name');
            console.log(a);
        }
        if (!bbb) {
            jQuery('#rstreet3').css('border-color', '#c22020');
            errors.push('Please fill the street');
        }
        if (!ccc) {
            jQuery('#raptunit3').css('border-color', '#c22020');
            errors.push('Please fill the aptmnt or unit');
            console.log(c);
        }
        if (!ddd) {
            jQuery('#rcity3').css('border-color', '#c22020');
            errors.push('Please fill city');
        }
        if (!eee) {
            jQuery('#rstate3').css('border-color', '#c22020');
            errors.push('Please enter state');
        }
        if (!fff) {
            jQuery('#rzip3').css('border-color', '#c22020');
            errors.push('Please enter zip');
        }
        if (!ggg) {
            console.log(g);
            jQuery('#movin3').css('border-color', '#c22020');
            errors.push('Please enter the Moved in date');
        }
        if (ggg) {
            if (yearcheck(ggg) == false) {
                jQuery('#movin3').css('border-color', '#c22020');
                errors.push('Please enter the Moved in date');
            }
        }
        if (!hhh) {
            console.log(g);
            jQuery('#mrent3').css('border-color', '#c22020');
            errors.push('Please enter the monthly rent');
        }




    }


    return errors;
}
// Called when token created successfully.
// Set the token as the value for the token input
var successCallback = function(data) {
    //alert('1callback');

    var myForm = document.getElementById('msform');
    myForm.token.value = data.response.token.token;
    // var ac = myForm.address_count.value;
    var ptype = myForm.payment_type.value;
    var lndname = myForm.lndlrdname.value;
    var rstreet = myForm.rstreet.value;
    var raptunit = myForm.raptunit.value;
    var rcity = myForm.rcity.value;
    var rstate = myForm.rstate.value;
    var rzip = myForm.rzip.value;
    var movin = myForm.movin.value;
    var mrent = myForm.mrent.value;
    var token = data.response.token.token;
    // if (ac > 1) {
    //     var lndname2 = myForm.lndlrdname2.value;
    //     var rstreet2 = myForm.rstreet2.value;
    //     var raptunit2 = myForm.raptunit2.value;
    //     var rcity2 = myForm.rcity2.value;
    //     var rstate2 = myForm.rstate2.value;
    //     var rzip2 = myForm.rzip2.value;
    //     var movin2 = myForm.movin2.value;
    //     var mrent2 = myForm.mrent2.value;
    // }

    // if (ac == 3) {
    //     var lndname3 = myForm.lndlrdname3.value;
    //     var rstreet3 = myForm.rstreet3.value;
    //     var raptunit3 = myForm.raptunit3.value;
    //     var rcity3 = myForm.rcity3.value;
    //     var rstate3 = myForm.rstate3.value;
    //     var rzip3 = myForm.rzip3.value;
    //     var movin3 = myForm.movin3.value;
    //     var mrent3 = myForm.mrent3.value;
    // }
    var plan = jQuery('input[name=plan]:checked').val();
    // var file = document.getElementById('docs').files[0];
    if(document.getElementById('docs')){
            var file = document.getElementById('docs').files[0];
        }else{
            var file = '';
        }
    // alert(file);
        var data = new FormData();
        data.append("action", "lnd_payment");
        if (file != '') {
            data.append('docs_upload', file, file.name);
        }
        
        data.append("token", token);
        data.append("ptype", ptype);
        data.append("lndname", lndname);
        data.append("rstreet", rstreet);
        data.append("raptunit", raptunit);
        data.append("rcity", rcity);
        data.append("rstate", rstate);
        data.append("rzip", rzip);
        data.append("movin", movin);
        data.append("mrent", mrent);
        data.append("plan", plan);
        // alert('plan : '+ plan);
        // if(plan != ''){
        //     if (plan == '1') {
        //         var plan_name = 'Monthly';
        //         var plan_amt = '9.99';
        //         var plan_period = '1 Month';
        //         var plan_setup_fee = '29.99';
        //         var plan_desc = 'Only onw time setup fee. Up to one year of previous rental history reported.';
        //         var total_amt = '50';
        //     }else{
        //         var plan_name = 'Annual';
        //         var plan_amt = '83.88';
        //         var plan_period = '1 Month';
        //         var plan_setup_fee = '29.99';
        //         var plan_desc = '30% discount off the monthly fee. Only onw time setup fee. Up to one year of previous rental history reported. ';
        //         var total_amt = '113';
        //     }
        // }

    jQuery(myForm).css('opacity', '0.3');
    jQuery(myForm).append('<img class="temp_waiting" src="http://winwintradelines.com/staging/wp-content/plugins/winwin_tradelines/images/waiting.gif"  />')
    // IMPORTANT: Here we call `submit()` on the form element directly instead of using jQuery to prevent and infinite token request loop.
    //myForm.submit();
    // ac: ac,
    //         lndname2: lndname2,
    //         rstreet2: rstreet2,
    //         raptunit2: raptunit2,
    //         rcity2: rcity2,
    //         rstate2: rstate2,
    //         rzip2: rzip2,
    //         movin2: movin2,
    //         mrent2: mrent2,
    //         lndname3: lndname3,
    //         rstreet3: rstreet3,
    //         raptunit3: raptunit3,
    //         rcity3: rcity3,
    //         rstate3: rstate3,
    //         rzip3: rzip3,
    //         movin3: movin3,
    //         mrent3: mrent3
    // {
    //         action: 'lnd_payment',
    //         token: data.response.token.token,
    //         ptype: ptype,
    //         lndname: lndname,
    //         rstreet: rstreet,
    //         raptunit: raptunit,
    //         rcity: rcity,
    //         rstate: rstate,
    //         rzip: rzip,
    //         movin: movin,
    //         mrent: mrent,
    //         plan: plan,
            

    //     }
    jQuery.ajax({
        url: winwin_object.winwin_ajax_url,
        type: 'post',
        data: data,
        cache: false,
        dataType: 'json',
        processData: false, // Don't process the files
        contentType: false, // Set content type to false as jQuery will tell the server its a query string request
        success: function(response) {
            // alert('Response :'+response.html+ 'Result : '+ response.dbstat);
            jQuery('.temp_waiting').remove();
            jQuery(myForm).css('opacity', '1');
            jQuery('.entry-content').append(response.html);
            if (response.dbstat == 'Success') {
                document.location.href = response.redirect;
            }

        }
    });
};
// Called when token creation fails.
var errorCallback = function(data) {
    if (data.errorCode === 200) {
        // alert('in error 200');
        tokenRequest();
    } else {
        alert(data.errorMsg);
    }
};
var tokenRequest = function() {
    // Setup token request arguments
    // alert('in token');
    var args = {
        sellerId: "901364382",
        publishableKey: "C26A82CD-6641-4371-9A9B-E62B1EDC54FA",
        // sellerId: "901386093",
        // publishableKey: "4DF47287-75A3-4BFA-A1BC-DE208B2116AB",
        ccNo: $("#ccNo").val(),
        cvv: $("#cvv").val(),
        expMonth: $("#expMonth").val(),
        expYear: $("#expYear").val()
    };
    // Make the token request
    TCO.requestToken(successCallback, errorCallback, args);
};

function isValidEmailAddress(emailAddress) {
    var pattern = /^([a-z\d!#$%&'*+\-\/=?^_`{|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+(\.[a-z\d!#$%&'*+\-\/=?^_`{|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+)*|"((([ \t]*\r\n)?[ \t]+)?([\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*(([ \t]*\r\n)?[ \t]+)?")@(([a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF][a-z\d\-._~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]*[a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])\.)+([a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF][a-z\d\-._~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]*[a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])\.?$/i;
    return pattern.test(emailAddress);
};
// Called when token created successfully.
// Set the token as the value for the token input
var successCallbackc = function(data) {
    // alert('2callback');
    var order_id = jQuery('button.winwin_checkout').data('id');
    var total = jQuery('span.total').text();
    var fname = jQuery('#fname').val();
    var lname = jQuery('#lname').val();
    var street = jQuery('#street').val();
    var state = jQuery('#state').val();
    var city = jQuery('#city').val();
    var zip = jQuery('#zip').val();
    var email = jQuery('#bemail').val();
    var phone = jQuery('#phone').val();
    var altphone = jQuery('#altphone').val();
    var ssn = jQuery('#ssn').val();
    var legalstatus = jQuery('#legal_status').val();
    var dob = jQuery('#dob').val();
    var ccku = jQuery('#cckuname').val();
    var cckp = jQuery('#cckpass').val();
    jQuery('#winwin_cart').css('opacity', '0.3');
    jQuery('#winwin_cart').append('<img class="temp_waiting" src="http://test.webzler.com/bob/wp-content/plugins/winwin_tradelines/images/waiting.gif" />');
    // IMPORTANT: Here we call `submit()` on the form element directly instead of using jQuery to prevent and infinite token request loop.
    //myForm.submit();
    jQuery.ajax({
        url: winwin_object.winwin_ajax_url,
        type: 'post',
        data: {
            action: 'winwin_two_checkout',
            token: data.response.token.token,
            id: order_id,
            total: total,
            fname: fname,
            lname: lname,
            street: street,
            state: state,
            city: city,
            zip: zip,
            email: email,
            phone: phone,
            altphone: altphone,
            ssn: ssn,
            legalstatus: legalstatus,
            dob: dob,
            ccku: ccku,
            cckp: cckp
        },
        success: function(response) {
            // alert(response);
            jQuery('.temp_waiting').remove();
            jQuery('#winwin_cart').css('opacity', '1');
            jQuery('.entry-content').append(response.html);
            console.log(response);
            //jQuery('.add_to_cart_result').html(response);
            if (response.change == 'yes') {
                //var its = jQuery.parseJSON(response.items);
                console.log('response');
            } else if (response.returnurl) {
                console.log(response.returnurl);
                window.location.href = response.returnurl;
                //window.location(response.returnurl);
                //console.log(response.returnurl);
            } else {
                if (response.dbfail) {
                    console.log(response);
                }
            }
        }
    });
};
// Called when token creation fails.
var errorCallbackc = function(data) {
    if (data.errorCode === 200) {
        tokenRequestc();
        alert(data.errorMsg);
    } else {
        alert(data.errorMsg);
    }
};
var tokenRequestc = function() {
    //console.log('hai');
    // Setup token request arguments
    var args = {
        sellerId: "901364382",
        publishableKey: "C26A82CD-6641-4371-9A9B-E62B1EDC54FA",
        ccNo: jQuery("#ccNo").val(),
        cvv: jQuery("#cvv").val(),
        expMonth: jQuery("#expMonth").val(),
        expYear: jQuery("#expYear").val()
    };
    // Make the token request
    TCO.requestToken(successCallbackc, errorCallbackc, args);
};

function stripeTokenRequestRA(){
    // alert('Token Request');
    //set your publishable key
    Stripe.setPublishableKey('pk_test_eCPvNiAbkc8grNwQrIlVtYNM');

    //create single-use token to charge the user
        Stripe.createToken({
            number: $("#ccNo").val(),
            cvc: $("#cvv").val(),
            exp_month: $("#expMonth").val(),
            exp_year: $("#expYear").val()
        }, stripeResponseHandlerRA);
}


// callback to handle the response from stripe
function stripeResponseHandlerRA(status, response) {
    if (response.error) {
        //enable the submit button
        // $('#payBtn').removeAttr("disabled");
        //display the errors on the form
        // $(".payment-errors").html(response.error.message);
        alert("Error : " + response.error.message);
    } else {
        // var form$ = $("#paymentFrm");
        //get token id

        var token = response['id'];
        var plan = jQuery('input[name=plan]:checked').val();
        
        var myForm = document.getElementById('msform');
        // myForm.token.value = data.response.token.token;
        // var ac = myForm.address_count.value;
        var ptype = myForm.payment_type.value;
        var lndname = myForm.lndlrdname.value;
        var rstreet = myForm.rstreet.value;
        var raptunit = myForm.raptunit.value;
        var rcity = myForm.rcity.value;
        var rstate = myForm.rstate.value;
        var rzip = myForm.rzip.value;
        var movin = myForm.movin.value;
        var mrent = myForm.mrent.value;

        if(document.getElementById('docs')){
            var file = document.getElementById('docs').files[0];
        }else{
            var file = '';
        }
        // alert(file);
        var data = new FormData();
        data.append("action", "lnd_stripe_payment");
        if (file != '') {
            data.append('docs_upload', file, file.name);
        }
        
        data.append("token", token);
        data.append("ptype", ptype);
        data.append("lndname", lndname);
        data.append("rstreet", rstreet);
        data.append("raptunit", raptunit);
        data.append("rcity", rcity);
        data.append("rstate", rstate);
        data.append("rzip", rzip);
        data.append("movin", movin);
        data.append("mrent", mrent);
        data.append("plan", plan);
        // data.append("mrent", mrent);


        jQuery(myForm).css('opacity', '0.3');
        jQuery(myForm).append('<img class="temp_waiting" src="http://winwintradelines.com/staging/wp-content/plugins/winwin_tradelines/images/waiting.gif"  />')
        // alert('above ajax');
        jQuery.ajax({
            url: winwin_object.winwin_ajax_url,
            type: 'post',
            data: data,
            cache: false,
            dataType: 'json',
            processData: false, // Don't process the files
            contentType: false, // Set content type to false as jQuery will tell the server its a query string request
            success: function(response) {
                // alert('Response :'+response);
                jQuery('.temp_waiting').remove();
                jQuery(myForm).css('opacity', '1');
                jQuery('.entry-content').append(response.html);
                if (response.dbstat == 'Success') {
                    document.location.href = response.redirect;
                }

            }
        });
     }
}
// function check(){
     
//      // alert(file);
//     //  var myForm = document.getElementById('msform');
//     var file = document.getElementById('docs').files[0];
//     var data = new FormData();
//     data.append("action", "docs_upload");
//     data.append('docs_upload', file, file.name);
//     // $.each(file, function(key, value)
//     //     {

//             // data.append("docs_upload", document.getElementById('docs').files[0]);
//         // });
//     // var dataarr = array();
//     // var formData = new FormData();
//     // formData.append('image', document.getElementById('docs').files[0]); 
//      jQuery.ajax({
//             url: winwin_object.winwin_ajax_url,
//             type: 'post',
//             data: data,
//             cache: false,
//             dataType: 'json',
//             processData: false, // Don't process the files
//             contentType: false, // Set content type to false as jQuery will tell the server its a query string request
//             success: function(response) {
//                 alert('Response :'+response.error);
//                 // jQuery('.temp_waiting').remove();
//                 // jQuery(myForm).css('opacity', '1');
//                 // jQuery('.entry-content').append(response.html);
//                 // if (response.dbstat == 'Success') {
//                 //     document.location.href = response.redirect;
//                 // }

//             }
//         });
// }
function stripeTokenRequest(){
    //set your publishable key
    Stripe.setPublishableKey('pk_test_eCPvNiAbkc8grNwQrIlVtYNM');

    //create single-use token to charge the user
        Stripe.createToken({
            number: jQuery("#ccNo").val(),
            cvc: jQuery("#cvv").val(),
            exp_month: jQuery("#expMonth").val(),
            exp_year: jQuery("#expYear").val()
        }, stripeResponseHandler);
        
        // // break this;
        // var ccNo = 
        // var cvv = ;
        // var expMonth = ;
        // var expYear = ;
}
// callback to handle the response from stripe
function stripeResponseHandler(status, response) {
    if (response.error) {
        //enable the submit button
        // $('#payBtn').removeAttr("disabled");
        //display the errors on the form
        // $(".payment-errors").html(response.error.message);
        alert("Error : " + response.error.message);
    } else {
        // var form$ = $("#paymentFrm");
        //get token id
        var token = response['id'];
        // alert(token);
        var order_id = jQuery('button.winwin_checkout').data('id');
        var total = jQuery('span.total').text();
        var fname = jQuery('#fname').val();
        var lname = jQuery('#lname').val();
        var street = jQuery('#street').val();
        var state = jQuery('#state').val();
        var city = jQuery('#city').val();
        var zip = jQuery('#zip').val();
        var email = jQuery('#bemail').val();
        var phone = jQuery('#phone').val();
        var altphone = jQuery('#altphone').val();
        var ssn = jQuery('#ssn').val();
        var legalstatus = jQuery('#legal_status').val();
        var dob = jQuery('#dob').val();
        var ccku = jQuery('#cckuname').val();
        var cckp = jQuery('#cckpass').val();
        jQuery('#winwin_cart').css('opacity', '0.3');
        jQuery('#winwin_cart').append('<img class="temp_waiting" src="http://test.webzler.com/bob/wp-content/plugins/winwin_tradelines/images/waiting.gif" />');
        // IMPORTANT: Here we call `submit()` on the form element directly instead of using jQuery to prevent and infinite token request loop.
        //myForm.submit();
        jQuery.ajax({
            url: winwin_object.winwin_ajax_url,
            type: 'post',
            data: {
                action: 'winwin_stripe',
                token: token,
                id: order_id,
                total: total,
                fname: fname,
                lname: lname,
                street: street,
                state: state,
                city: city,
                zip: zip,
                email: email,
                phone: phone,
                altphone: altphone,
                ssn: ssn,
                legalstatus: legalstatus,
                dob: dob,
                ccku: ccku,
                cckp: cckp
            },
            success: function(response) {
                // alert(response);
                jQuery('.temp_waiting').remove();
                jQuery('#winwin_cart').css('opacity', '1');
                jQuery('.entry-content').append(response.html);
                console.log(response);
                //jQuery('.add_to_cart_result').html(response);
                if (response.change == 'yes') {
                    //var its = jQuery.parseJSON(response.items);
                    console.log('response');
                } else if (response.returnurl) {
                    console.log(response.returnurl);
                    window.location.href = response.returnurl;
                    //window.location(response.returnurl);
                    //console.log(response.returnurl);
                } else {
                    if (response.dbfail) {
                        console.log(response);
                    }
                }
            }
        });

        //insert the token into the form
        // form$.append("<input type='hidden' name='stripeToken' value='" + token + "' />");
        // //submit form to the server
        // form$.get(0).submit();
    }
}
function birthdaycheck(bday) {

    var today = new Date();
    var dd = today.getDate();
    var yyyy = today.getFullYear();
    var mm = today.getMonth() + 1;
    var maxdate = new Date(yyyy - 18, mm - 1, dd);
    var mindate = new Date(yyyy - 90, mm, dd);
    var bd = new Date(Date.parse(bday));

    if (bd >= mindate && bd <= maxdate) {

        return true
        // throw error here..
    } else {
        return false;
    }

}


function yearcheck(bday) {

    var today = new Date();
    var dd = today.getDate();
    var yyyy = today.getFullYear();
    var mm = today.getMonth() + 1;
    var maxdate = today
    var mindate = new Date(yyyy - 90, mm, dd);
    var bd = new Date(Date.parse(bday));

    if (bd > mindate && bd <= maxdate) {

        return true
        // throw error here..
    } else {
        return false;
    }

}